import { MachineConfig, EventObject, State, StateSchema, Interpreter } from 'xstate';
interface HookArgs<TContext, TState extends StateSchema, TEvent extends EventObject> {
    config: MachineConfig<TContext, TState, TEvent>;
    options: any;
    initialContext: TContext;
    history?: any;
}
export declare function useRouterMachine<TContext = any, TState extends StateSchema = any, TEvent extends EventObject = any>(args: HookArgs<TContext, TState, TEvent>): {
    state: State<TContext, TEvent>;
    context: TContext;
    send: TSendFn<TContext, TEvent>;
    service: Interpreter<TContext, TState, TEvent>;
};
declare type TSendFn<TContext, TEvent extends EventObject> = (event: TEvent) => State<TContext, TEvent>;
export {};
