"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const xstate_router_1 = require("xstate-router");
const react_1 = require("react");
const xstate_1 = require("xstate");
function useRouterMachine(args) {
    const machine = react_1.useMemo(() => xstate_1.Machine(args.config, args.options, args.initialContext), []);
    const [state, setState] = react_1.useState(machine.initialState);
    const [context, setContext] = react_1.useState(machine.context);
    // Setup the service only once.
    const service = react_1.useMemo(() => {
        const service = xstate_router_1.routerMachine(args);
        setState(service.state);
        setContext(service.machine.context);
        service.onTransition(state => setState(state));
        service.onChange(ctx => setContext(ctx));
        return service;
    }, []);
    // Stop the service when unmounting.
    react_1.useEffect(() => {
        return () => {
            service.stop();
        };
    }, []);
    return { state, send: service.send, context, service };
}
exports.useRouterMachine = useRouterMachine;
